/*
 * CTick - ATL wrapper for a checkbox.
 *
 */
#include "stdafx.h"
#include "WindowVirt.h"

typedef CWinTraits<WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX > TickTraits;

class CTick : public CWindowImpl<CTick, CWindowVirt, TickTraits >
{
public:
	DECLARE_WND_SUPERCLASS(NULL, _T("BUTTON"))

   CTick()
   {
      m_isChecked = false;
   }

   CTick(bool checked)
   {
      m_isChecked = checked;
   }

   virtual ~CTick() { ::DestroyWindow(m_hWnd); }

    BEGIN_MSG_MAP(CTick)
    END_MSG_MAP()

	HWND Create(HWND hWndParent, RECT& rcPos, LPCTSTR szWindowName = NULL,
		DWORD dwStyle = 0, DWORD dwExStyle = 0,
		UINT nID = 0, LPVOID lpCreateParam = NULL)
	{
      CWindowImpl<CTick,CWindowVirt,TickTraits>::Create(hWndParent,rcPos,szWindowName
                                , dwStyle, dwExStyle, nID, lpCreateParam);

      if (m_isChecked) {
          ::SendMessage(m_hWnd, BM_SETCHECK, BST_CHECKED, 0L);
      }
	  return m_hWnd;
	}

protected:
   bool m_isChecked;
};
